#!/usr/bin/env python
# -*- coding: utf-8 -*-


"""
###################################################################
# BA_Conbagui_CaramelChocolateVanillaText.py Tutorial Scripted #
###################################################################
This script follows Conbagui's tutorial:
Caramel, Chocolate and Vanilla text tutorial as closely
as i could. 
=============================================================
This script should have received in a package containing:
=============================================================
Conbagui's Tutorial 
-----------------------------------------------------------------------------------------------------------
Caramel, Chocolate and Vanilla text.pdf
===========================================================================================================
4 gradients are used by the script that you must copy to your Gimp Gradients folder:
-----------------------------------------------------------------------------------------------------------
Caramel.ggr
Chocolate.ggr
Vanilla.ggr
Vanilla-2.ggr
===========================================================================================================
2 Fonts that are used in the tutorial that you must copy to your Gimp Fonts folder:
-----------------------------------------------------------------------------------------------------------
BRUSHSCI.TTF
TITANIA-REGULAR.TTF
===========================================================================================================
A Gimp .xcf file to open in Gimp before running the script contains
instruction/template and a completed example text layer.
-----------------------------------------------------------------------------------------------------------
BA_Conbagui_Caramel Chocolate Vanilla Text.xcf
===========================================================================================================
The python script to move to your Gimp plug-ins folder
-----------------------------------------------------------------------------------------------------------
BA_Conbagui_CaramelChocolateVanillaText.py
===========================================================================================================
And last, the instruction sheet
-----------------------------------------------------------------------------------------------------------
BA_Conbagui_CaramelChocolateVanillaText instructions.txt
===========================================================================================================
Open the BA_Conbagui_GoldBar_tutorial_template.xcf in gimp.  ##### <--- this blah blah has not been blah-blahed yet....
Follow the instructions for making your legend text on a     ##### <--- remember, keep your word and character count up! upupup! for gimp pointpointpoints
transparent layer of your creation.
Make sure that your text layer is at the top of the layer stack and 
that it is the active layer.
Run the script and you will receive your outcome.
You may then modify your legend text and re-run the script, 
or save the xcf with your legend text layer for later use.
===========================================================================================================
Hope that you enjoy the experience.
...................................................... 
####################
# COPYRIGHT NOTICE #
###############################################################################
# You should have received a copy of the GNU General Public License           #
# along with this program if not, you can view the GNU General Public         #
# License version 3 at the web site http://www.gnu.org/licenses/gpl-3.0.html  #
# Alternatively you can write to the Free Software Foundation, Inc., 675 Mass #
# Ave, Cambridge, MA 02139, USA.                                              #
###############################################################################
"""


from gimpfu import *
import os

def python_fu_text_to_logo_ba(text, margin, font, direction, just, letter_spacing, line_spacing, font_size,type, flatten):

	image = gimp.Image(font_size, font_size, RGB)

	# create layer with text and add it to the image: image, drawable, x, y, text, border, antialias, size, size_type, fontname
	text_layer = pdb.gimp_text_fontname(image, None, 0, 0, text, 0, 1, font_size, PIXELS, font)

	#pdb.gimp_image_resize_to_layers(image)
	# justification:
	pdb.gimp_text_layer_set_base_direction (text_layer, direction)
	pdb.gimp_text_layer_set_justification (text_layer, just)
	pdb.gimp_text_layer_set_letter_spacing(text_layer, letter_spacing)
	pdb.gimp_text_layer_set_line_spacing(text_layer, line_spacing)


	pdb.gimp_image_resize_to_layers(image)

	wi = pdb.gimp_image_width(image)
	hi = pdb.gimp_image_height(image)

	
	new_width = wi + 2*margin
	new_height = hi + 2*margin
	
	wh = pdb.gimp_drawable_width(text_layer)
	hh = pdb.gimp_drawable_height(text_layer)
	centerx=wi/2
	centery=hi/2
	adw=wh/2
	adh=hh/2
	sw=centerx - adw
	sh=centery - adh		
	pdb.gimp_layer_set_offsets(text_layer, sw, sh)
	pdb.gimp_image_resize(image,new_width,new_height,margin, margin)
	pdb.gimp_layer_resize_to_image_size(text_layer)
	    
	# create layer: image, width, height, type, name, opacity, mode
	layer = gimp.Layer(image, "background", image.width, image.height, RGBA_IMAGE, 100, 0)
	if type==0:
		black     ='#000000'
		caramelbg ='#120a00'
		caramelgr1='#a97537'
		caramelgr2='#d9b997'
		caramelbv1='#fbcf91'
		pdb.gimp_context_push()
		image = pdb.gimp_image_new(image.width, image.height,RGB)
		frozen= pdb.gimp_image_undo_freeze(image)
		background=gimp.Image.new_layer(image)
		alpha=pdb.gimp_drawable_has_alpha(background)
		if not alpha:
			pdb.gimp_layer_add_alpha (background)
		background.name=('Background')
		pdb.gimp_context_set_background(caramelbg)
		pdb.gimp_edit_fill(background,FILL_BACKGROUND) 
		gradientlay=gimp.Image.new_layer(image)
		gradientlay.name='Layer'
		pdb.gimp_context_set_foreground(caramelgr1)
		pdb.gimp_edit_blend(gradientlay,BLEND_FG_TRANSPARENT,LAYER_MODE_NORMAL_LEGACY,GRADIENT_RADIAL,100,0.0,REPEAT_NONE,False,False,1,0,True,800,0,800,900)
		pdb.gimp_context_set_foreground(caramelgr1)
		pdb.gimp_edit_blend(gradientlay,BLEND_FG_TRANSPARENT,LAYER_MODE_NORMAL_LEGACY,GRADIENT_RADIAL,100,0.0,REPEAT_NONE,False,False,1,0,True,800,0,800,700)
		background = pdb.gimp_image_flatten(image)
		pdb.plug_in_gauss_rle2(image, background,400,400)
		pdb.plug_in_gauss_rle2(image, background,400,400)
		####### get text
		caramel = pdb.gimp_layer_new_from_drawable(text_layer,image) 
		image.add_layer(caramel)
		alpha=pdb.gimp_drawable_has_alpha(caramel)
		if not alpha:
			pdb.gimp_layer_add_alpha (caramel)
		caramel.name = 'Caramel'
		pdb.gimp_context_set_foreground('#b57111')      
		pdb.gimp_image_select_item(image,0,caramel)
		pdb.gimp_edit_fill(caramel,0) 
		pdb.gimp_selection_none(image)

		pdb.script_fu_layerfx_drop_shadow(image,caramel,black,75.0,0,0,2,0,9,130,5,1,0)
		pdb.script_fu_layerfx_bevel_emboss(image,caramel,1,65,0,9,16,130.0,45,5,caramelbv1,4,75,black,2,75,6,0,0)    
		pdb.script_fu_layerfx_gradient_overlay(image, caramel,'Caramel',0,0,0,100.0,5,800,450,90,900,0)
		caramel2 = pdb.gimp_layer_copy(caramel, 1)
		pdb.gimp_image_add_layer(image,caramel2, 0)
		caramel2.name='Caramel copy'
		caramel2.mode=LAYER_MODE_NORMAL_LEGACY
		pdb.gimp_item_set_visible(caramel2,False) 
		pdb.script_fu_layerfx_drop_shadow(image,caramel,black,45.0,0,0,2,0,5,120,5,0,0)
		pdb.script_fu_layerfx_bevel_emboss(image,caramel,1,65,0,18,5,130.0,45.0,5,black,4,100,'#633800',2,75,6,0,0) #black looks better
		visible = pdb.gimp_layer_new_from_visible(image,image,'visible')
		pdb.gimp_image_add_layer(image,visible, 0)
		if flatten:
			background.name=('Caramel')
			pdb.gimp_image_flatten(image)
		pdb.gimp_context_pop()
		#pdb.gimp_displays_flush
		#disp1=pdb.gimp_display_new(image)
		
		
	if type==1:
		pdb.gimp_context_push()
		black     ='#000000'
		white     ='#ffffff'
		image = pdb.gimp_image_new(image.width, image.height,RGB)
		frozen= pdb.gimp_image_undo_freeze(image)
		background=gimp.Image.new_layer(image)
		alpha=pdb.gimp_drawable_has_alpha(background)
		if not alpha:
			pdb.gimp_layer_add_alpha (background)
		background.name=('Background')
		pdb.gimp_context_set_background('#120a00')
		pdb.gimp_edit_fill(background,FILL_BACKGROUND) 
		gradientlay=gimp.Image.new_layer(image)
		gradientlay.name='Layer'
		pdb.gimp_context_set_foreground('#652213')     #was('#432213')
		pdb.gimp_edit_blend(gradientlay,BLEND_FG_TRANSPARENT,LAYER_MODE_NORMAL_LEGACY,GRADIENT_RADIAL,100,0.0,REPEAT_NONE,False,False,1,0,True,800,0,800,900)
		pdb.gimp_context_set_foreground('#432213')     #  was('#d9b997')
		pdb.gimp_edit_blend(gradientlay,BLEND_FG_TRANSPARENT,LAYER_MODE_NORMAL_LEGACY,GRADIENT_RADIAL,100,0.0,REPEAT_NONE,False,False,1,0,True,800,0,800,700)
		background = pdb.gimp_image_flatten(image)
		pdb.plug_in_gauss_rle2(image, background,400,400)
		pdb.plug_in_gauss_rle2(image, background,400,400)
		####### get text
		chocolate = pdb.gimp_layer_new_from_drawable(text_layer,image) 
		image.add_layer(chocolate)
		alpha=pdb.gimp_drawable_has_alpha(chocolate)
		if not alpha:
			pdb.gimp_layer_add_alpha (chocolate)
		chocolate.name = 'Chocolate'
		pdb.gimp_context_set_foreground('#590000')      # tried a bit light #5f1f00 was chocotext ='#201200'     
		pdb.gimp_image_select_item(image,0,chocolate)
		pdb.gimp_edit_fill(chocolate,0)
		pdb.gimp_selection_none(image)

		pdb.script_fu_layerfx_drop_shadow(image,chocolate,black,75.0,0,0,2,0,9,130,5,1,0)
		pdb.script_fu_layerfx_bevel_emboss(image,chocolate,1,65,0,9,16,130.0,45,5,'#533524',4,75,black,2,75,6,0,0)    
		pdb.script_fu_layerfx_gradient_overlay(image, chocolate,'Chocolate #1',0,0,0,50.0,18,800,450,90,1000,0)
		chocolate2 = pdb.gimp_layer_copy(chocolate, 1)
		pdb.gimp_image_add_layer(image,chocolate2, 0)
		chocolate2.name='Chocolate copy'
		chocolate2.mode=LAYER_MODE_NORMAL_LEGACY
		pdb.gimp_item_set_visible(chocolate2,False) 
		pdb.script_fu_layerfx_drop_shadow(image,chocolate,black,45.0,0,0,2,0,14,130,8,1,0)
		pdb.script_fu_layerfx_bevel_emboss(image,chocolate,1,65,0,18,5,130.0,45.0,3,white,4,100,'#291604',2,75,6,0,0) 
		visible = pdb.gimp_layer_new_from_visible(image,image,'visible')
		pdb.gimp_image_add_layer(image,visible, 0)
		if flatten:
			background.name=('Chocolate')
			pdb.gimp_image_flatten(image)
		pdb.gimp_context_pop()
		#pdb.gimp_displays_flush
		#disp2=pdb.gimp_display_new(image)
#################### end chocolate image ###########################
	if type==2:
		pdb.gimp_context_push()
		black     ='#000000'        
		white     ='#ffffff'
		pdb.gimp_context_set_gradient('Vanilla')
		image = pdb.gimp_image_new(image.width, image.height,RGB)
		frozen3= pdb.gimp_image_undo_freeze(image)
		background=gimp.Image.new_layer(image)
		alpha=pdb.gimp_drawable_has_alpha(background)
		if not alpha:
			pdb.gimp_layer_add_alpha (background)
		background.name=('Background')
		pdb.gimp_edit_blend(background,3,0,0,100,0.0,REPEAT_NONE,FALSE,False,1,0,True,800,900,800,0)
		####### get text
		vanilla = pdb.gimp_layer_new_from_drawable(text_layer,image) 
		image.add_layer(vanilla)
		alpha=pdb.gimp_drawable_has_alpha(vanilla)
		if not alpha:
			pdb.gimp_layer_add_alpha (vanilla)
		vanilla.name = 'Vanilla'
		pdb.gimp_context_set_foreground(black)      
		pdb.gimp_image_select_item(image,0,vanilla)
		pdb.gimp_edit_fill(vanilla,0) 
		pdb.gimp_selection_none(image)

		pdb.script_fu_layerfx_drop_shadow(image,vanilla,'#c9c7be',75.0,0,0,2,10,17,60.0,14,1,0)
		pdb.script_fu_layerfx_inner_shadow(image,vanilla,white,100,0,0,0,0,0,17,55,7,0)
		pdb.script_fu_layerfx_bevel_emboss(image,vanilla,1,65,0,10,16,-110.0,20.0,0,'#fbef91',2,75.0,black,2,0.0,6,0,0)
		pdb.script_fu_layerfx_gradient_overlay(image, vanilla,'Vanilla 2',0,0,0,100.0,0,800,450,90,300,0)

		pdb.script_fu_layerfx_drop_shadow(image,vanilla,'#c2c0b4',75.0,0,0,2,0,30,60.0,20,1,0)
		pdb.script_fu_layerfx_bevel_emboss(image,vanilla,1,65,0,7,16,90.0,60.0,0,'#ffffff',0,100.0,'#f8f8f8',6,100.0,6,0,0)
		visible = pdb.gimp_layer_new_from_visible(image,image,'visible')
		pdb.gimp_image_add_layer(image,visible, 0)
		if flatten:
			background.name=('Vanilla')
			pdb.gimp_image_flatten(image)
		pdb.gimp_context_pop()
		#pdb.gimp_displays_flush
		#disp2=pdb.gimp_display_new(image)	
	# merge all layers
	if flatten:
	    image.merge_visible_layers(CLIP_TO_IMAGE)

	# display results
	try:
		gimp.Display(image)
	except:
		pass

register(
	"python_fu_text_to_logo_ba",
    "Script Based On Conbagui's GoldBar Tutorial",   
    "Requirments show at top",
    "animicule@gimpchat.com", 
    "Brian Andersen", 
    "July 2017",
    "BA_Conbagui Caramel Chocolate Vanilla Text", 
	"",
	[
        (PF_TEXT, 	"text", ("Text:"), "GIMP\nCHAT"),
        (PF_SPINNER, "margin", "Add border (px):", 50, (0, 500, 1)),
        (PF_FONT, "font", "Font:", "Arial"),
        (PF_OPTION,  "Direction", "Direction:", 0, ["From left to right",  "From right to left", "Vertical, right to left (mixed orientation)", "Vertical, right to left (upright orientation)", "Vertical, left to right (mixed orientation)", "Vertical, left to right (upright orientation)"]),
        (PF_OPTION, "just", "Justify:", 2, ["LEFT","RIGHT","CENTER","FILL"]),
        (PF_SPINNER, "letter_spacing", "Letter Spacing:", 0, (-100, 100, 1, 5, 0, 0)),
        (PF_SPINNER, "line_spacing", "Line Spacing:", 0, ( -100, 100, 1, 5, 0, 0)),
        (PF_INT, "font_size", "Font size (px):", 150),
        (PF_OPTION, "just", "Text type:", 2, ["Caramel Text","Chocolate Text","Vanilla Text"]),
        (PF_BOOL,  "flatten",      "Merge layers:", False),

	],
	[],
	python_fu_text_to_logo_ba,
	menu="<Image>/File/Create/Logos",
	)

main()

